/*
 * OSKA Posix implementation -- memory allocation
 *
 * Copyright (C) 2010 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#ifndef __OSKA_POSIX_ALLOC_H
#define __OSKA_POSIX_ALLOC_H

#include <stdlib.h>

static inline void *os_alloc(size_t size)
{
    return calloc(1, size);
}

static inline void *os_alloc_nonzeroed(size_t size)
{
    return malloc(size);
}

static inline void os_free(void *ptr)
{
    free(ptr);
}

static inline void *os_alloc_big(size_t size)
{
    return os_alloc(size);
}

static inline void os_free_big(void *ptr)
{
    os_free(ptr);
}

#endif /* #ifndef __OSKA_POSIX_ALLOC_H */
