/*
 * OSKA Posix implementation -- events
 *
 * Copyright (C) 2010 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#ifndef __OSKA_POSIX_EVENT_H
#define __OSKA_POSIX_EVENT_H

#include <pthread.h>

#include <oska/types.h>

typedef struct {
    uint16_t events;
    pthread_mutex_t mutex;
    pthread_cond_t cond;
} os_event_t;

void os_event_init(os_event_t *evt);
void os_event_destroy(os_event_t *evt);
uint16_t os_event_wait(os_event_t *evt);
uint16_t os_event_wait_timed(os_event_t *evt, unsigned timeout_ms);
void os_event_raise(os_event_t *evt, uint16_t events);

#endif /* #ifndef __OSKA_POSIX_EVENT_H */
