/*
 * OSKA Posix implementation -- mutexes
 *
 * Copyright (C) 2010 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#ifndef __OSKA_POSIX_MUTEX_H
#define __OSKA_POSIX_MUTEX_H

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

typedef pthread_mutex_t os_mutex_t;


static inline void os_mutex_init(os_mutex_t *mutex)
{
    pthread_mutex_init(mutex, NULL);
}

static inline void os_mutex_destroy(os_mutex_t *mutex)
{
    pthread_mutex_destroy(mutex);
}

static inline void os_mutex_lock(os_mutex_t *mutex)
{
    pthread_mutex_lock(mutex);
}

static inline void os_mutex_unlock(os_mutex_t *mutex)
{
    pthread_mutex_unlock(mutex);
}

#endif /* __OSKA_POSIX_MUTEX_H */
