/*
 * OSKA Posix implementation -- threading
 *
 * Copyright (C) 2010 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#ifndef __OSKA_POSIX_THREAD_H
#define __OSKA_POSIX_THREAD_H

#include <oska/event.h>

#include <pthread.h>

typedef struct os_thread_s {
    void (*func)(void *);
    void *arg;
    pthread_t id;
    int stop;
} os_thread_t;

int os_thread_create(os_thread_t *thread, const char *name,
                     void (*func)(void *), void *arg);
void os_thread_stop(os_thread_t *thread, os_event_t *evt);
int os_thread_should_stop(os_thread_t *thread);

#endif /* __OSKA_POSIX_THREAD_H */
