/*
 * OSKA Posix implementation -- timing
 *
 * Copyright (C) 2010 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#ifndef __OSKA_LINUX_TIME_H
#define __OSKA_LINUX_TIME_H

#include <sys/time.h>

static inline unsigned long os_current_time_ms(void)
{
    struct timeval cur_time;

    gettimeofday(&cur_time, NULL);
    return (cur_time.tv_sec * 1000) + (cur_time.tv_usec / 1000);
}

static inline void os_sleep_ms(unsigned ms)
{
    usleep(ms * 1000);
}

static inline void os_delay_us(unsigned us)
{
    usleep(us);
}

#define os_time_after(a, b) ((long)(b) - (long)(a) < 0)

#endif /* __OSKA_LINUX_TIME_H */
