/*
 * OSKA Posix thread functions.
 *
 * Copyright (C) 2010 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#include <oska/thread.h>

int os_thread_create(os_thread_t *thread, const char *name, void (*func)(void *), void *arg)
{
    return pthread_create(&thread->id, NULL, (void *) func, arg);
}

void os_thread_stop(os_thread_t *thread, os_event_t *evt)
{
    thread->stop = 1;

    if (evt) {
        os_event_raise(evt, ~0);
    }

    pthread_join(thread->id, NULL);
}

int os_thread_should_stop(os_thread_t *thread)
{
    return thread->stop;
}
