/*
 * OSKA Windows KMDF implementation -- memory allocation.
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#include <oska/alloc.h>

void *os_alloc_big(size_t size)
{
    return ExAllocatePoolWithTag(NonPagedPool, size, OSKA_POOL_TAG);
}

void os_free_big(void *ptr)
{
    if (ptr) {
        ExFreePoolWithTag(ptr, OSKA_POOL_TAG);
    }
}
