/*
 * Windows KMDF event functions.
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#pragma once
#include <ntddk.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    KEVENT event;
    KSPIN_LOCK lock;
    uint16_t events;
} os_event_t;

void os_event_init(os_event_t *evt);

__inline os_event_destroy(os_event_t *evt)
{
    /* no op */
}

uint16_t os_event_wait(os_event_t *evt);

__inline uint16_t os_event_wait_interruptible(os_event_t *evt)
{
    return os_event_wait(evt);
}

uint16_t os_event_wait_timed(os_event_t *evt, unsigned timeout_ms);

void os_event_raise(os_event_t *evt, uint16_t events);

#ifdef __cplusplus
} /* extern "C" */
#endif
