/*
 * OSKA Windows KMDF implementation -- mutexes.
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#pragma once
#include <ntddk.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef FAST_MUTEX os_mutex_t;

__inline void os_mutex_init(os_mutex_t *mutex)
{
    ExInitializeFastMutex(mutex);
}

__inline void os_mutex_destroy(os_mutex_t *mutex)
{
    /* no op */
}

__drv_raisesIRQL(APC_LEVEL)
__drv_savesIRQLGlobal(OldIrql, mutex)
__inline void os_mutex_lock(os_mutex_t *mutex)
{
    ExAcquireFastMutex(mutex);
}

__drv_requiresIRQL(APC_LEVEL)
__drv_restoresIRQLGlobal(OldIrql, mutex)
__inline void os_mutex_unlock(os_mutex_t *mutex)
{
    ExReleaseFastMutex(mutex);
}

#ifdef __cplusplus
} /* extern "C" */
#endif
