/*
 * OSKA Windows KMDF implementation -- debugger printing.
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#include <oska/print.h>
#include <stdarg.h>

void os_vprint(enum os_print_level level, const char *prefix, const char *name,
               const char *format, va_list args)
{
    vKdPrintEx((DPFLTR_IHVDRIVER_ID, level, format, args));
}

void os_print(enum os_print_level level, const char *prefix, const char *name,
              const char *format, ...)
{
    va_list va_args;

    va_start(va_args, format);
    os_vprint(level, prefix, name, format, va_args);
    va_end(va_args);
}
