/*
 * Windows KMDF thread functions.
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#pragma once
#include <ntddk.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    void (*func)(void *);
    void *arg;
    PKTHREAD thread;
    int stop;
} os_thread_t;

int os_thread_create(os_thread_t *thread, const char *name,
                     void (*func)(void *), void *arg);

void os_thread_stop(os_thread_t *thread, os_event_t *evt);

int os_thread_should_stop(os_thread_t *thread);

__inline void os_try_suspend_thread(os_thread_t *thread)
{
    /* no op */
}

#ifdef __cplusplus
} /* extern "C" */
#endif
