/*
 * OSKA Windows KMDF implementation -- timing.
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#include <oska/time.h>

unsigned long os_current_time_ms(void)
{
    LARGE_INTEGER t;

    KeQueryTickCount(&t);
    return (t.QuadPart * KeQueryTimeIncrement() / 10000ll) & 0xffffffff;
}

void os_sleep_ms(unsigned ms)
{
    LARGE_INTEGER t;

    t.QuadPart = -(ms * 10000ll);
    KeDelayExecutionThread(KernelMode, FALSE, &t);
}

void os_delay_us(unsigned us)
{
    LARGE_INTEGER t;

    t.QuadPart = -(us * 10ll);
    KeDelayExecutionThread(KernelMode, FALSE, &t);
}
