/*
 * OSKA Windows KMDF implementation -- timers.
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#pragma once
#include <ntddk.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    os_timer_func_t func;
    void *arg;
    KTIMER timer;
    KDPC dpc;
} os_timer_t;

void os_timer_init(os_timer_t *timer, os_timer_func_t func, void *arg);
void os_timer_destroy(os_timer_t *timer);

void os_timer_set(os_timer_t *timer, unsigned long expires_ms);

__inline os_timer_cancel(os_timer_t *timer)
{
    KeCancelTimer(&timer->timer);
}

#ifdef __cplusplus
} /* extern "C" */
#endif
