/*
 * OSKA Windows KMDF implementation -- tracing messages.
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#pragma once

#ifndef WPP_CONTROL_GUIDS
/*
 * Default control GUID if a module doesn't provide their own.
 */
#define WPP_CONTROL_GUIDS                                               \
    WPP_DEFINE_CONTROL_GUID(OskaTraceGuid,                              \
                            (2321f755,b4c1,4910,a3b3,7d71e11af8b3),     \
                            WPP_DEFINE_BIT(OS_TRACE_DFLT)               \
        )
#endif

// begin_wpp config
// FUNC os_trace_err{LEVEL=TRACE_LEVEL_ERROR,FLAGS=OS_TRACE_DFLT}(MSG, ...);
// FUNC os_trace_warn{LEVEL=TRACE_LEVEL_WARNING,FLAGS=OS_TRACE_DFLT}(MSG, ...);
// FUNC os_trace_info{LEVEL=TRACE_LEVEL_INFORMATION,FLAGS=OS_TRACE_DFLT}(MSG, ...);
// FUNC os_trace_dbg{LEVEL=TRACE_LEVEL_VERBOSE,FLAGS=OS_TRACE_DFLT}(MSG, ...);
// end_wpp

#define WPP_LEVEL_FLAGS_LOGGER(lvl, flags) WPP_LEVEL_LOGGER(flags)
#define WPP_LEVEL_FLAGS_ENABLED(lvl, flags)                             \
    (WPP_LEVEL_ENABLED(flags) && WPP_CONTROL(WPP_BIT_## flags).Level >= lvl)

#define OS_TRACE_INCLUDE_TMH
