/*
 * Windows KMDF standard types and error codes.
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#pragma once
#include <ntddk.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef INT8 int8_t;
typedef UINT8 uint8_t;
typedef INT16 int16_t;
typedef UINT16 uint16_t;
typedef INT32 int32_t;
typedef UINT32 uint32_t;
typedef INT64 int64_t;
typedef UINT64 uint64_t;

typedef BOOLEAN bool;
#define false FALSE
#define true TRUE

enum __os_error_codes {
    EAGAIN = -STATUS_DEVICE_BUSY,
    EINVAL = -STATUS_INVALID_PARAMETER,
    EIO = -STATUS_IO_DEVICE_ERROR,
    ENODEV = -STATUS_NO_SUCH_DEVICE,
    ENOMEM = -STATUS_INSUFFICIENT_RESOURCES,
    ENOTSUPP = -STATUS_NOT_SUPPORTED,
    ENXIO = -STATUS_NOT_FOUND,
    ETIMEDOUT = -STATUS_IO_TIMEOUT,
};

int os_ntstatus_to_err(NTSTATUS status);
NTSTATUS os_err_to_ntstatus(int errno);

#ifdef __cplusplus
} /* extern "C" */
#endif
