/*
 * OSKA Zoran HCE implementation -- memory allocation
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#ifndef __OSKA_ZORAN_ALLOC_H
#define __OSKA_ZORAN_ALLOC_H

#include "Allocator.h"

static inline void *os_alloc(size_t size)
{
    void* mem = PoolAlloc(NULL, size, POOL_MEMORY_CACHED);
    if(mem)
    	memset(mem, 0x00, size);
    return mem;
}

static inline void os_free(void *ptr)
{
	PoolFree(NULL, ptr);
}

static inline void *os_alloc_big(size_t size)
{
    void* mem = PoolAlloc(NULL, size, POOL_MEMORY_CACHED);
    if(mem)
    	memset(mem, 0x00, size);
    return mem;
}

static inline void os_free_big(void *ptr)
{
	PoolFree(NULL, ptr);
}

#endif /* #ifndef __OSKA_ZORAN_ALLOC_H */
