/*
 * OSKA Zoran HCE implementation -- mutexes
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#ifndef __OSKA_ZORAN_MUTEX_H
#define __OSKA_ZORAN_MUTEX_H

#include "Os.h"

typedef TX_SEMAPHORE os_mutex_t;

/* os_mutex_lock() wait option */
#define __OSKA_ZORAN_MUTEX_GET_WAIT	TX_WAIT_FOREVER

static inline void os_mutex_init(os_mutex_t *mutex)
{
	OsSemaphoreCreate(mutex, "oska_mutex", 1);
}

static inline void os_mutex_destroy(os_mutex_t *mutex)
{
	OsSemaphoreDelete(mutex);
}

static inline void os_mutex_lock(os_mutex_t *mutex)
{
	OsSemaphoreGet(mutex, __OSKA_ZORAN_MUTEX_GET_WAIT);
}

static inline void os_mutex_unlock(os_mutex_t *mutex)
{
	OsSemaphorePut(mutex);
}

#endif /* __OSKA_ZORAN_MUTEX_H */
