/*
 * OSKA Zoran HCE implementation -- semaphores
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#ifndef __OSKA_ZORAN_SEMAPHORE_H
#define __OSKA_ZORAN_SEMAPHORE_H

#include "Os.h"

typedef TX_SEMAPHORE os_semaphore_t;

/* os_mutex_lock() wait option */
#define __OSKA_ZORAN_SEMAPHORE_GET_WAIT	TX_WAIT_FOREVER

static inline void os_semaphore_init(os_semaphore_t *sem)
{
	OsSemaphoreCreate(sem, "oska_semaphore", 0);
}

static inline void os_semaphore_wait(os_semaphore_t *sem)
{
	OsSemaphoreGet(sem, __OSKA_ZORAN_SEMAPHORE_GET_WAIT);
}

static inline void os_semaphore_post(os_semaphore_t *sem)
{
	OsSemaphorePut(sem);
}

#endif /* __OSKA_LINUX_SEMAPHORE_H */
