/*
 * OSKA Zoran HCE implementation -- threading
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#ifndef __OSKA_ZORAN_THREAD_H
#define __OSKA_ZORAN_THREAD_H

#include "Os.h"

struct os_thread_lx {
    void (*func)(void *);
    void *arg;
    TX_THREAD *task;
    int stop;
};

typedef struct os_thread_lx os_thread_t;

int os_thread_create(os_thread_t *thread, const char *name,
                     void (*func)(void *), void *arg);
void os_thread_stop(os_thread_t *thread, os_semaphore_t *sem);
int os_thread_should_stop(os_thread_t *thread);

#endif /* __OSKA_ZORAN_THREAD_H */
