/*
 * OSKA Zoran HCE implementation -- timing
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#ifndef __OSKA_ZORAN_TIME_H
#define __OSKA_ZORAN_TIME_H

#include "Os.h"

static inline unsigned long os_current_time_ms(void)
{
    return OsTimeGet() * OS_MICRO_SEC_IN_ONE_TICK;
}

static inline void os_sleep_ms(unsigned ms)
{
	OsThreadSleepMS(ms);
}

static inline void os_delay_us(unsigned us)
{
	OsThreadSleepMS(CEIL_DIV(us, OS_MICRO_IN_MILLI));
}

#endif /* __OSKA_ZORAN_TIME_H */
