/*
 * Sdioemb Windows KMDF core DLL entry/exit points.
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#define WPP_CONTROL_GUIDS                                               \
    WPP_DEFINE_CONTROL_GUID(SdioembTraceGuid,                           \
                            (9748c8a5,d4fe,418e,be67,2e181f2baf2e),     \
                            WPP_DEFINE_BIT(OS_TRACE_DFLT)               \
        )
#include "../core/sdio_internal.h"

#include "sdioemb.tmh"

/*
 * FIXME: consider making these tweakable via the registry.
 */
int sdioemb_card_poll_interval_ms = 500;
int sdioemb_max_bus_freq = 0;
uint16_t sdioemb_max_block_size = 0;

NTSTATUS DllInitialize(IN PUNICODE_STRING RegistryPath)
{
    int ret;

    WPP_INIT_TRACING(NULL, RegistryPath);

    sdio_core_init();
    return STATUS_SUCCESS;
}

NTSTATUS DllUnload(void)
{
    sdio_core_clean_up();
    WPP_CLEANUP(NULL);
    return STATUS_SUCCESS;
}

DRIVER_INITIALIZE DriverEntry;

NTSTATUS DriverEntry(
    IN OUT PDRIVER_OBJECT DriverObject,
    IN PUNICODE_STRING    RegistryPath)
{
    return STATUS_SUCCESS;
}

void sdio_os_event_log_init(struct sdioemb_slot *slot)
{
    /* Event logging is initialized in the slot driver library. */
}

void sdio_os_event_log_deinit(struct sdioemb_slot *slot)
{
}
