/*
 * Windows KMDF SDIO slot driver registry access.
 *
 * Copyright (C) 2010 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#include <oska/all.h>
#include <ntstrsafe.h>

#include <sdioemb/slot_api.h>
#include <sdioemb/windows/slot_api.h>

NTSTATUS sdioemb_wdf_query_ulong(WDFDEVICE device,
                                 const UNICODE_STRING *value_name, ULONG *value)
{
    static DECLARE_CONST_UNICODE_STRING(sdioemb_key_name, L"Sdioemb");
    WDFKEY hardware_key = NULL, sdioemb_key = NULL;
    NTSTATUS status;

    status = WdfDeviceOpenRegistryKey(device, PLUGPLAY_REGKEY_DEVICE, KEY_READ,
                                      WDF_NO_OBJECT_ATTRIBUTES, &hardware_key);
    if (!NT_SUCCESS(status)) {
        goto out;
    }
    status = WdfRegistryOpenKey(hardware_key, &sdioemb_key_name, KEY_READ,
                                WDF_NO_OBJECT_ATTRIBUTES, &sdioemb_key);
    if (!NT_SUCCESS(status)) {
        goto out;
    }
    status = WdfRegistryQueryULong(sdioemb_key, value_name, value);
    if (!NT_SUCCESS(status)) {
        goto out;
    }
  out:
    if (sdioemb_key) {
        WdfRegistryClose(sdioemb_key);
    }
    if (hardware_key) {
        WdfRegistryClose(hardware_key);
    }
    return status;
}
