/*
 * Internal header for the WDF slot driver library.
 *
 * Copyright (C) 2010 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#pragma once

#include "../../../core/sdio_config.h"

typedef struct sdioemb_wdf_event_log_info {
    struct sdioemb_slot *slots[SDIOEMB_SLOTS_MAX];
} SDIOEMB_WDF_EVENT_LOG_INFO, *PSDIOEMB_WDF_EVENT_LOG_INFO;
WDF_DECLARE_CONTEXT_TYPE_WITH_NAME(SDIOEMB_WDF_EVENT_LOG_INFO, sdioemb_wdf_get_event_log_info);

typedef struct sdioemb_wdf_child_list_context {
    struct sdioemb_slot *slot;
} SDIOEMB_WDF_CHILD_LIST_CONTEXT, *PSDIOEMB_WDF_CHILD_LIST_CONTEXT;
WDF_DECLARE_CONTEXT_TYPE_WITH_NAME(SDIOEMB_WDF_CHILD_LIST_CONTEXT,
                                   sdioemb_wdf_get_child_list_context);

void sdioemb_wdf_event_log_add_slot(struct sdioemb_slot *slot);
void sdioemb_wdf_event_log_del_slot(struct sdioemb_slot *slot);
