/*
 * Sdioemb Windows KMDF SHC driver -- DMA support.
 *
 * Copyright (C) 2009 Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#include "shc_internal.h"

NTSTATUS shc_dma_init(WDFDEVICE device)
{
    struct shc_device_context *ctx = shc_get_device_context(device);
    WDF_DMA_ENABLER_CONFIG config;
    NTSTATUS status;

    WDF_DMA_ENABLER_CONFIG_INIT(&config, WdfDmaProfilePacket, SHC_DMA_BUFFER_LEN);

    status = WdfDmaEnablerCreate(device, &config, WDF_NO_OBJECT_ATTRIBUTES,
                                 &ctx->dma_enabler);

    return status;
}
