/*
 * Sdioemb Userspace Interface driver for Windows.
 *
 * Copyright (C) Cambridge Silicon Radio Ltd.
 *
 * Refer to LICENSE.txt included with this source code for details on
 * the license terms.
 */
#pragma once
#include <oska/trace.h>
#include <oska/all.h>

#include <wdf.h>

#include <sdioemb/windows/sdio_api.h>
#include <sdioemb/windows/uif.h>

typedef struct uif_device_context {
    struct sdioemb_wdf_interface interface;
    bool added;
    bool active;
    WDFQUEUE queue;
    os_thread_t request_thread;
    os_event_t request_event;
    os_spinlock_t interrupt_lock;
    bool interrupt_pending;
    WDFREQUEST wait_for_int_request;
} UIF_DEVICE_CONTEXT, *PUIF_DEVICE_CONTEXT;
WDF_DECLARE_CONTEXT_TYPE_WITH_NAME(UIF_DEVICE_CONTEXT, uif_get_device_context);

typedef struct uif_request_context {
    WDFMEMORY data;
} UIF_REQUEST_CONTEXT, *PUIF_REQUEST_CONTEXT;
WDF_DECLARE_CONTEXT_TYPE_WITH_NAME(UIF_REQUEST_CONTEXT, uif_get_request_context);

int uif_register(void);
void uif_unregister(void);
void uif_init_file_config(PWDFDEVICE_INIT device_init);
NTSTATUS uif_create_interface(WDFDEVICE device);
